; ýűʹ HM VNISEdit ű༭򵼲
!include "StrFunc.nsh"
${StrRep}

; װʼ峣
!define PRODUCT_NAME "MOKA Factory Tools"
!define PRODUCT_VERSION "3.1.0.1"
!define PRODUCT_PUBLISHER "MOKA"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\MOKA Factory Tools.exe"
!define UNINSTALL_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

SetCompressor lzma

; ------ MUI ִ涨 (1.67 汾ϼ) ------
!include "MUI.nsh"

; MUI Ԥ峣
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; ѡ񴰿ڳ
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; ӭҳ
!insertmacro MUI_PAGE_WELCOME
; Эҳ
!insertmacro MUI_PAGE_LICENSE "../Licence.txt"
; װĿ¼ѡҳ
!insertmacro MUI_PAGE_DIRECTORY
; װҳ
!insertmacro MUI_PAGE_INSTFILES
; װҳ
!define MUI_FINISHPAGE_RUN "$INSTDIR\MOKA Factory Tools.exe"
!insertmacro MUI_PAGE_FINISH

; װжعҳ
!insertmacro MUI_UNPAGE_INSTFILES

; װ
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "SimpChinese"

; װԤͷļ
!insertmacro MUI_RESERVEFILE_LANGDLL
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
; ------ MUI ִ涨 ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "UpgradeSetup${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\MOKA Factory Tools"
InstallDirRegKey HKLM "${PRODUCT_UNINST_KEY}" "UninstallString"
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "../bin\Release\System.Data.SQLite.xml"
  CreateDirectory "$SMPROGRAMS\MOKA Factory Tools"
  CreateShortCut "$SMPROGRAMS\MOKA Factory Tools\MOKA Factory Tools.lnk" "$INSTDIR\MOKA Factory Tools.exe"
  CreateShortCut "$DESKTOP\MOKA Factory Tools.lnk" "$INSTDIR\MOKA Factory Tools.exe"
  ;Delete "$INSTDIR\Config.json"
  File "../bin\Release\System.Data.SQLite.dll"
  File "../bin\Release\MOKA Factory Tools.exe"
  File "../bin\Release\MOKA Factory Tools.exe.config"
  File "../bin\Release\Newtonsoft.Json.dll"
  File "../bin\Release\CSkin.xml"
  File "../bin\Release\CSkin.dll"
  File "../bin\Release\route-ping.bat"
  File "../bin\Release\route-tracert.bat"
  ;File "../bin\Release\Config.json"
  SetOutPath "$INSTDIR\x86"
  File "../bin\Release\x86\*.*"
  SetOutPath "$INSTDIR\x64"
  File "../bin\Release\x64\*.*"
  SetOutPath "$INSTDIR\zh-CN"
  File "../bin\Release\zh-CN\*.*"
SectionEnd


Section -AdditionalIcons
  CreateShortCut "$SMPROGRAMS\MOKA Factory Tools\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\MOKA Factory Tools.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\MOKA Factory Tools.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

#--  NSIS ű༭ Function α Section ֮дԱⰲװδԤ֪⡣--#

Function .onInit
  Call RemoveOld
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

/******************************
 *  ǰװжز  *
 ******************************/

Section Uninstall
  Delete "$INSTDIR\uninst.exe"
  ;Delete "$INSTDIR\Config.json"
  Delete "$INSTDIR\CSkin.dll"
  Delete "$INSTDIR\CSkin.xml"
  Delete "$INSTDIR\Devaof.DB.SqlBuilder.dll"
  Delete "$INSTDIR\Devaof.DB.SQLite.dll"
  Delete "$INSTDIR\Newtonsoft.Json.dll"
  Delete "$INSTDIR\MOKA Factory Tools.exe"
  Delete "$INSTDIR\MOKA Factory Tools.exe.config"
  Delete "$INSTDIR\MOKA Fartory Tools Server.exe"
  Delete "$INSTDIR\MOKA Fartory Tools Server.exe.config"
  Delete "$INSTDIR\System.Data.SQLite.dll"
  Delete "$INSTDIR\System.Data.SQLite.xml"
  Delete "$SMPROGRAMS\MOKA Factory Tools\Uninstall.lnk"
  Delete "$DESKTOP\MOKA Factory Tools.lnk"
  Delete "$SMPROGRAMS\MOKA Factory Tools\MOKA Factory Tools.lnk"
  RMDir "$SMPROGRAMS\MOKA Factory Tools"
  RMDir "$INSTDIR"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd

#--  NSIS ű༭ Function α Section ֮дԱⰲװδԤ֪⡣--#

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "ȷʵҪȫƳ $(^Name) е" IDYES +2
  Abort
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) ѳɹشļƳ"
FunctionEnd

Function RemoveOld
  # ȡעϢ;
  ReadRegStr $0 HKLM "${UNINSTALL_KEY}\SCBC Factory Tools" "UninstallString"
  ${IF} $0 != ""
    MessageBox MB_ICONINFORMATION|MB_OK "⵽ɵİװƳ"
    ${StrRep} $R1 $0 "\uninst.exe" ""
    # ļ;
    CopyFiles "$R1\Config.json" "$INSTDIR\Config.json"
    CopyFiles "$R1\Error.db" "$INSTDIR\Error.db"
    CopyFiles "$R1\Keys" "$INSTDIR\Keys"
    CopyFiles "$R1\log" "$INSTDIR\log"
    CopyFiles "$R1\download" "$INSTDIR\download"
    # ɾעϢ;
    Delete "$R1\uninst.exe"
    Delete "$R1\CSkin.dll"
    Delete "$R1\CSkin.xml"
    Delete "$R1\Devaof.DB.SqlBuilder.dll"
    Delete "$R1\Devaof.DB.SQLite.dll"
    Delete "$R1\Newtonsoft.Json.dll"
    Delete "$R1\SCBC Factory Tools.exe"
    Delete "$R1\SCBC Factory Tools.exe.config"
    Delete "$R1\SCBC Fartory Tools Server.exe"
    Delete "$R1\SCBC Fartory Tools Server.exe.config"
    Delete "$R1\System.Data.SQLite.dll"
    Delete "$R1\System.Data.SQLite.xml"
    Delete "$SMPROGRAMS\SCBC Factory Tools\Uninstall.lnk"
    Delete "$DESKTOP\SCBC Factory Tools.lnk"
    Delete "$SMPROGRAMS\SCBC Factory Tools\SCBC Factory Tools.lnk"
    RMDir "$SMPROGRAMS\SCBC Factory Tools"
    DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SCBC Factory Tools"
    DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\App Paths\SCBC Factory Tools.exe"
  ${ENDIF}
FunctionEnd
